package zer01hd.zer10hdbot;

import java.util.Scanner;

import javax.security.auth.login.LoginException;

import net.dv8tion.jda.core.AccountType;
import net.dv8tion.jda.core.JDABuilder;
import net.dv8tion.jda.core.entities.Game;
import net.dv8tion.jda.core.exceptions.RateLimitedException;

public class Main {
	public static void main(String[] args) {
		boolean alive = true;
		Scanner in = new Scanner(System.in);

		boolean ninja = false;
		String token = null;
		if (args != null) {
			for (int argID = 0; argID < args.length; argID++) {
				if (args[argID].equals("-ninja")) {
					ninja = true;
				} else if (args[argID].equals("-token")) {
					argID++;
					token = args[argID];
				}
			}
		}
		JDABuilder jdab;
		if (!ninja) {
			jdab = new JDABuilder(AccountType.BOT);
			jdab.setGame(Game.of("with your soul"));
		} else {
			jdab = new JDABuilder(AccountType.CLIENT);
		}
		if (token != null) {
			jdab.setToken(token);
		} else {
			jdab.setToken("MzQ3NjQyODI2Nzc3MTY1ODI0.DHbXfA.I-puwf_NHIn0ap7Q1BaGsb2_VIU");
		}

		try {
			Zer10HDBot z10b = new Zer10HDBot(jdab);
			while (alive) {
				System.out.println("Awaiting for next command...");
				String command = in.nextLine().toLowerCase();
				if (command.equals("initiate")) {
					System.out.println("attempting initiation.\n");
					z10b.initiate();
				} else if (command.equals("connect")) {
					z10b.connect(jdab);
				} else if (command.equals("setup listeners")) {
					z10b.setupListeners();
				} else if (command.equals("stop")) {
					z10b.jda.shutdown();
					System.out.println("Shutting things down!");
					alive = false;
					in.close();
				} else if (command.equals("force-shutdown")) {
					z10b.jda.shutdownNow();
					System.out.println("Shutting things down with force!");
					alive = false;
					in.close();
				} else if (command.equals("set prefix")) {
					System.out.println("please enter the prefix you want: ");
					
					z10b.cmdPrefix = in.nextLine();
					System.out.println("command prefix set: " + z10b.cmdPrefix);
				} else if (command.equals("run hotswap script")) {
					System.out.println("running hotswap script...");
					z10b.tempScript();
				} else if (command.equals("tttw")) {
					System.out.println("What would you like to send to the weebs?");
					if (z10b.jda.getGuildById(348161059175006208l) != null) {
						z10b.jda.getGuildById(348161059175006208l).getTextChannels().get(0).sendMessage(in.nextLine()).queue();
					} else {
						System.out.println("error sending to channel. Null channel.");
					}
				}
			}
		} catch (IllegalArgumentException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (LoginException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (RateLimitedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
}
